EDBFrame = CreateFrame("Frame", "EDBFrame")

EDB = {};
function EDBEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB:CreateFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() EDB:GuildFrameUpdated() end);
		end
	elseif(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
		if(prefix=="EDB") then
			if(msg=="request sync") then
				EDB:SYNC();
			else
				name=string.sub(msg,1,string.find(msg,":")-1);
				MS=string.sub(msg,string.find(msg,":")+1,string.find(msg,";")-1);
				OS=string.sub(msg,string.find(msg,";")+1,string.find(msg,"@")-1);
				updated=tonumber(string.sub(msg,string.find(msg,"@")+1, -1));
				if(ELGOHDB[name]) then
					if(ELGOHDB[name]["updated"]<updated) then
						ELGOHDB[name]["MS"]=MS;
						ELGOHDB[name]["OS"]=OS;
						ELGOHDB[name]["updated"]=updated;
						print("Elgoh: Updated "..name);
					end
				else
					ELGOHDB[name]={}
					ELGOHDB[name]["MS"]=MS;
					ELGOHDB[name]["OS"]=OS;
					ELGOHDB[name]["updated"]=updated;
					print("Elgoh: Added "..name);
				end
			end
		end
	end
end

EDBFrame:SetScript("OnEvent", EDBEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");

function EDB:CreateFrame()
	if (GuildMemberDetailFrame) then
		EDBFrame:SetParent(GuildMemberDetailFrame);
		EDBFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
		EDBFrame:SetHeight(55);
		EDBFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "BOTTOMLEFT", 0, 5);
		EDBFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
		
		EDBMSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBMSText:SetHeight(10);
		EDBMSText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBOSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBOSText:SetHeight(10);
		EDBOSText:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		
		if(ELGOH:Officer()) then
			EDBButton=CreateFrame("Button",nil,EDBFrame,"UIMenuButtonStretchTemplate")
			EDBButton:RegisterForClicks("AnyUp");
			EDBButton:SetScript("OnShow", nil);
			EDBButton:SetScript("OnMouseDown", nil);
			EDBButton:SetScript("OnMouseUp", nil);
			EDBButton:SetScript("OnClick", EDBEDIT);
			EDBButton:SetPoint("RIGHT", "EDBFrame", "RIGHT", -5,0);
			EDBButton:SetWidth(25)
			EDBButton:SetHeight(EDBFrame:GetHeight()-10)
			EDBButton:SetText("+");
		end
	end
end

function EDB:GuildFrameUpdated()
	local pname,rank= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if pname == EDB.selected then return end
		EDB.selected = pname;
		EDB:UpdateLines(pname);
	end
end

function EDB:UpdateLines(who)
	if(ELGOHDB[who]) then
		EDBMSText:SetText("MS: "..ELGOHDB[who]["MS"]);
		EDBOSText:SetText("OS: "..ELGOHDB[who]["OS"]);
	else
		EDBMSText:SetText("No DB entry for "..who);
		EDBOSText:SetText(":(");
	end
end

function EDB:ADD(member,MS,OS)
	ELGOHDB[member]={};
	ELGOHDB[member]["MS"]=MS;
	ELGOHDB[member]["OS"]=OS;
	ELGOHDB[member]["updated"]=time();
end

function EDB:SYNC()
	for i = 1, GetNumGuildMembers(), 1 do 
		name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
		if(ELGOHDB[name]) then
			SendAddonMessage("EDB", name..":"..ELGOHDB[name]["MS"]..";"..ELGOHDB[name]["OS"].."@"..ELGOHDB[name]["updated"], "GUILD");
		end
	end
end

function EDBEDIT()
EditingName=GetGuildRosterInfo(GetGuildRosterSelection());
editmembername:SetText("Editing "..EditingName);
if(ELGOHDB[EditingName]) then
	EDBNewMS:SetText(ELGOHDB[EditingName]["MS"])
	EDBNewOS:SetText(ELGOHDB[EditingName]["OS"])
else
	EDBNewMS:SetText("No DB entry for "..EditingName);
	EDBNewOS:SetText(":(");
end
	frmEDBADD:Show();
end

function EDB:Report(Short)
	local MSTanks=0;
	local MSHeals=0;
	local MSMelee=0;
	local MSRanged=0;
	local OSTanks=0;
	local OSHeals=0;
	local OSMelee=0;
	local OSRanged=0;
	local NID=0;

	for i = 1, GetNumGuildMembers(), 1 do 
	if(Short) then
		name, rank, rankIndex, level,_,_,_,_, online = GetGuildRosterInfo(i);
	else
		name, rank, rankIndex, level= GetGuildRosterInfo(i);
		online=1;
	end
		if(rank~="Alts" and rank~="Leader Alts" and rank~="Social Member" and level==85 and online) then
			if(ELGOHDB[name]) then
				if(ELGOHDB[name]["MS"]=="Tank") then MSTanks=MSTanks+1; end
				if(ELGOHDB[name]["MS"]=="Healer") then MSHeals=MSHeals+1; end
				if(ELGOHDB[name]["MS"]=="Ranged DPS") then MSRanged=MSRanged+1; end
				if(ELGOHDB[name]["MS"]=="Melee DPS") then MSMelee=MSMelee+1; end
				
				if(ELGOHDB[name]["OS"]=="Tank") then OSTanks=OSTanks+1; end
				if(ELGOHDB[name]["OS"]=="Healer") then OSHeals=OSHeals+1; end
				if(ELGOHDB[name]["OS"]=="Ranged DPS") then OSRanged=OSRanged+1; end
				if(ELGOHDB[name]["OS"]=="Melee DPS") then OSMelee=OSMelee+1; end
			else
				NID=NID+1;
			end
		end
	end
	if(Short==1) then
		PostTo("Online Spec Report:");
	else
		PostTo("Full Spec Report:");
		PostTo("("..NID.." characters weren't in the database)");
		PostTo(" ");
	end
	PostTo("Tanks: "..MSTanks);
	PostTo("Healers: "..MSHeals);
	if(MSRanged==1) then word="is"; else word="are"; end
	if(Short==1) then
		PostTo("DPS: "..(MSRanged+MSMelee).." ("..MSRanged.." "..word.." Ranged)")
	else
		PostTo("DPS: "..(MSRanged+MSMelee).." ["..MSRanged.." ("..string.format("%.0f",((MSRanged/(MSRanged+MSMelee))*100)).."%) "..word.." Ranged]")
		PostTo(" ");
		PostTo("Offspec Tanks: "..OSTanks);
		PostTo("Offspec Healers: "..OSHeals);
		PostTo("Offspec DPS: "..(OSRanged+OSMelee).." ["..MSRanged.." ("..string.format("%.0f",((OSRanged/(OSRanged+OSMelee))*100)).."%) "..word.." Ranged]")
	end
--	PostTo("Not including Alts or Officer Alts");
end

function EDB:Handle(self,button)
	if(button=="RightButton") then
		if(self:GetName()=="btnMSTank") then EDBNewOS:SetText("Tank"); end
		if(self:GetName()=="btnMSMelee") then EDBNewOS:SetText("Melee DPS"); end
		if(self:GetName()=="btnMSRanged") then EDBNewOS:SetText("Ranged DPS"); end
		if(self:GetName()=="btnMSHealer") then EDBNewOS:SetText("Healer"); end
	else
		if(self:GetName()=="btnMSTank") then EDBNewMS:SetText("Tank"); end
		if(self:GetName()=="btnMSMelee") then EDBNewMS:SetText("Melee DPS"); end
		if(self:GetName()=="btnMSRanged") then EDBNewMS:SetText("Ranged DPS"); end
		if(self:GetName()=="btnMSHealer") then EDBNewMS:SetText("Healer"); end
	end
end
